public class ConditionalExpression extends Expression
{ Expression test;
  Expression ifExp;
  Expression elseExp;

  public ConditionalExpression(Expression t, Expression ie, Expression ee)
  { test = t; ifExp = ie; elseExp = ee; }

  public String queryForm(java.util.Map env, boolean local)
  { String tqf = test.queryForm(env, local);
    String lqf = ifExp.queryForm(env, local);
    String rqf = elseExp.queryForm(env, local);
    return "(" + tqf + ") ? (" + lqf + ") : (" + rqf + ")";
  }
    
  public String queryFormJava6(java.util.Map env, boolean local)
  { String tqf = test.queryFormJava6(env, local);
    String lqf = ifExp.queryFormJava6(env, local);
    String rqf = elseExp.queryFormJava6(env, local);
    return "(" + tqf + ") ? (" + lqf + ") : (" + rqf + ")";
  }

  public String queryFormJava7(java.util.Map env, boolean local)
  { String tqf = test.queryFormJava7(env, local);
    String lqf = ifExp.queryFormJava7(env, local);
    String rqf = elseExp.queryFormJava7(env, local);
    return "(" + tqf + ") ? (" + lqf + ") : (" + rqf + ")";
  }

  public String queryFormCSharp(java.util.Map env, boolean local)
  { String tqf = test.queryFormCSharp(env, local);
    String lqf = ifExp.queryFormCSharp(env, local);
    String rqf = elseExp.queryFormCSharp(env, local);
    return "(" + tqf + ") ? (" + lqf + ") : (" + rqf + ")";
  }

  public String queryFormCPP(java.util.Map env, boolean local)
  { String tqf = test.queryFormCPP(env, local);
    String lqf = ifExp.queryFormCPP(env, local);
    String rqf = elseExp.queryFormCPP(env, local);
    return "(" + tqf + ") ? (" + lqf + ") : (" + rqf + ")";
  }

  public String updateForm(java.util.Map env, boolean local)
  { String tqf = test.queryForm(env, local);
    String lqf = ifExp.updateForm(env, local);
    String rqf = elseExp.updateForm(env, local);
    return "  if (" + tqf + ") { " + lqf + " }\n" +
                "  else { " + rqf + " }";
  }

  public String updateFormJava6(java.util.Map env, boolean local)
  { String tqf = test.queryFormJava6(env, local);
    String lqf = ifExp.updateFormJava6(env, local);
    String rqf = elseExp.updateFormJava6(env, local);
    return "  if (" + tqf + ") { " + lqf + " }\n" +
                "  else { " + rqf + " }";
  }

  public String updateFormJava7(java.util.Map env, boolean local)
  { String tqf = test.queryFormJava7(env, local);
    String lqf = ifExp.updateFormJava7(env, local);
    String rqf = elseExp.updateFormJava7(env, local);
    return "  if (" + tqf + ") { " + lqf + " }\n" +
                "  else { " + rqf + " }";
  }

  public String updateFormCSharp(java.util.Map env, boolean local)
  { String tqf = test.queryFormCSharp(env, local);
    String lqf = ifExp.updateFormCSharp(env, local);
    String rqf = elseExp.updateFormCSharp(env, local);
    return "  if (" + tqf + ") { " + lqf + " }\n" +
                "  else { " + rqf + " }";
  }

  public String updateFormCPP(java.util.Map env, boolean local)
  { String tqf = test.queryFormCPP(env, local);
    String lqf = ifExp.updateFormCPP(env, local);
    String rqf = elseExp.updateFormCPP(env, local);
    return "  if (" + tqf + ") { " + lqf + " }\n" +
                "  else { " + rqf + " }";
  }
}
 