import java.util.Vector; 

public abstract class TemplateExp
{ Attribute bindsTo;
  Expression where;

  public TemplateExp(Attribute v, Expression e)
  { bindsTo = v;
    where = e;
  }

  public abstract boolean typeCheck(Vector types, Vector entities, Vector contexts, Vector env);  

  public abstract Expression toSourceExpression(Vector bound, Expression contextObj);

  public abstract Expression toTargetExpression(Vector bound, Expression contextObj, Expression setting);

  public abstract Expression toTargetExpressionOp(Vector bound, Expression contextObj, Expression setting);
}
